diff --git a/src/or/connection_edge.c b/src/or/connection_edge.c
index 186137b..5448330 100644
--- a/src/or/connection_edge.c
+++ b/src/or/connection_edge.c
@@ -701,6 +701,7 @@ typedef struct {
 /** Entry for mapping addresses to which virtual address we mapped them to. */
 typedef struct {
   char *ipv4_address;
+  char *ipv6_address;
   char *hostname_address;
 } virtaddress_entry_t;
 
@@ -749,6 +750,7 @@ addressmap_virtaddress_ent_free(void *_ent)
 
   ent = _ent;
   tor_free(ent->ipv4_address);
+  tor_free(ent->ipv6_address);
   tor_free(ent->hostname_address);
   tor_free(ent);
 }
@@ -765,9 +767,11 @@ addressmap_virtaddress_remove(const char *address, addressmap_entry_t *ent)
     if (ve) {
       if (!strcmp(address, ve->ipv4_address))
         tor_free(ve->ipv4_address);
+      if (!strcmp(address, ve->ipv6_address))
+        tor_free(ve->ipv6_address);
       if (!strcmp(address, ve->hostname_address))
         tor_free(ve->hostname_address);
-      if (!ve->ipv4_address && !ve->hostname_address) {
+      if (!ve->ipv4_address && !ve->ipv6_address && !ve->hostname_address) {
         tor_free(ve);
         strmap_remove(virtaddress_reversemap, ent->new_address);
       }
@@ -1132,19 +1136,18 @@ client_dns_set_addressmap_impl(const char *address, const char *name,
  * <b>ttl</b>seconds; otherwise, we use the default.
  */
 void
-client_dns_set_addressmap(const char *address, uint32_t val,
+client_dns_set_addressmap(const char *address, tor_addr_t *val,
                           const char *exitname,
                           int ttl)
 {
-  struct in_addr in;
+  tor_addr_t a;
   char valbuf[INET_NTOA_BUF_LEN];
 
   tor_assert(address);
 
-  if (tor_inet_aton(address, &in))
+  if (tor_inet_pton(AF_UNSPEC, address, &a))
     return; /* If address was an IP address already, don't add a mapping. */
-  in.s_addr = htonl(val);
-  tor_inet_ntoa(&in,valbuf,sizeof(valbuf));
+  tor_addr_to_str(val,valbuf,sizeof(valbuf),0);
 
   client_dns_set_addressmap_impl(address, valbuf, exitname, ttl);
 }
@@ -1194,7 +1197,7 @@ int
 parse_virtual_addr_network(const char *val, int validate_only,
                            char **msg)
 {
-  uint32_t addr;
+  tor_addr_t addr, nxt;
   uint16_t port_min, port_max;
   maskbits_t bits;
 
@@ -1217,11 +1220,12 @@ parse_virtual_addr_network(const char *val, int validate_only,
   if (validate_only)
     return 0;
 
-  virtual_addr_network = (uint32_t)( addr & (0xfffffffful << (32-bits)) );
+  virtual_addr_network = (uint32_t)( tor_addr_to_ipv4h(&addr) & (0xfffffffful << (32-bits)) );
   virtual_addr_netmask_bits = bits;
 
-  if (addr_mask_cmp_bits(next_virtual_addr, addr, bits))
-    next_virtual_addr = addr;
+  tor_addr_from_ipv4n(&addr, htonl(next_virtual_addr));
+  if (tor_addr_mask_cmp_bits(&nxt, &addr, bits))
+    next_virtual_addr = tor_addr_to_ipv4h(&addr);
 
   return 0;
 }
@@ -1233,14 +1237,13 @@ parse_virtual_addr_network(const char *val, int validate_only,
 static int
 address_is_in_virtual_range(const char *address)
 {
-  struct in_addr in;
+  tor_addr_t a, b;
   tor_assert(address);
   if (!strcasecmpend(address, ".virtual")) {
     return 1;
-  } else if (tor_inet_aton(address, &in)) {
-    uint32_t addr = ntohl(in.s_addr);
-    if (!addr_mask_cmp_bits(addr, virtual_addr_network,
-                            virtual_addr_netmask_bits))
+  } else if (tor_inet_pton(AF_UNSPEC, address, &a)) {
+    tor_addr_from_ipv4n(&b, virtual_addr_network);
+    if (!tor_addr_mask_cmp_bits(&a, &b, virtual_addr_netmask_bits))
       return 1;
   }
   return 0;
@@ -1248,18 +1251,21 @@ address_is_in_virtual_range(const char *address)
 
 /** Increment the value of next_virtual_addr; reset it to the start of the
  * virtual address range if it wraps around.
+ * XXX-IPv6: IPv4-only
  */
 static INLINE void
 increment_virtual_addr(void)
 {
+  tor_addr_t nxt, vnet;
   ++next_virtual_addr;
-  if (addr_mask_cmp_bits(next_virtual_addr, virtual_addr_network,
-                         virtual_addr_netmask_bits))
+  tor_addr_from_ipv4n(&nxt, htonl(next_virtual_addr));
+  tor_addr_from_ipv4n(&vnet, htonl(virtual_addr_network));
+  if (tor_addr_mask_cmp_bits(&nxt, &vnet, virtual_addr_netmask_bits))
     next_virtual_addr = virtual_addr_network;
 }
 
 /** Return a newly allocated string holding an address of <b>type</b>
- * (one of RESOLVED_TYPE_{IPV4|HOSTNAME}) that has not yet been mapped,
+ * (one of RESOLVED_TYPE_{IPV4|HOSTNAME|IPV6}) that has not yet been mapped,
  * and that is very unlikely to be the address of any real host.
  *
  * May return NULL if we have run out of virtual addresses.
@@ -1309,6 +1315,10 @@ addressmap_get_virtual_address(int type)
       }
     }
     return tor_strdup(buf);
+  } else if (type == RESOLVED_TYPE_IPV6) {
+    /* XXX-IPv6: implement this */
+    log_warn(LD_CONFIG, "IPv6 code missing in this spot");
+    return NULL;
   } else {
     log_warn(LD_BUG, "Called with unsupported address type (%d)", type);
     return NULL;
@@ -1341,8 +1351,9 @@ addressmap_register_virtual_address(int type, char *new_address)
     vent_needs_to_be_added = 1;
   }
 
-  addrp = (type == RESOLVED_TYPE_IPV4) ?
-    &vent->ipv4_address : &vent->hostname_address;
+  addrp = (type == RESOLVED_TYPE_IPV4 ? &vent->ipv4_address :
+           type == RESOLVED_TYPE_IPV6 ? &vent->ipv6_address :
+                                        &vent->hostname_address);
   if (*addrp) {
     addressmap_entry_t *ent = strmap_get(addressmap, *addrp);
     if (ent && ent->new_address &&
@@ -1382,8 +1393,9 @@ addressmap_register_virtual_address(int type, char *new_address)
     vent = strmap_get(virtaddress_reversemap, new_address);
     tor_assert(vent);
     tor_assert(!strcasecmp(*addrp,
-                           (type == RESOLVED_TYPE_IPV4) ?
-                           vent->ipv4_address : vent->hostname_address));
+                           (type == RESOLVED_TYPE_IPV4 ? vent->ipv4_address
+                            type == RESOLVED_TYPE_IPv6 ? vent->ipv6_address :
+                                                         vent->hostname_address));
     log_info(LD_APP, "Map from %s to %s okay.",
              safe_str_client(*addrp),
              safe_str_client(new_address));
@@ -1544,7 +1556,7 @@ connection_ap_handshake_rewrite_and_attach(edge_connection_t *conn,
   socks_request_t *socks = conn->socks_request;
   hostname_type_t addresstype;
   or_options_t *options = get_options();
-  struct in_addr addr_tmp;
+  tor_addr_t addr_tmp;
   /* We set this to true if this is an address we should automatically
    * remap to a local address in VirtualAddrNetwork */
   int automap = 0;
@@ -1562,14 +1574,14 @@ connection_ap_handshake_rewrite_and_attach(edge_connection_t *conn,
             socks->port);
 
   if (socks->command == SOCKS_COMMAND_RESOLVE &&
-      !tor_inet_aton(socks->address, &addr_tmp) &&
+      !tor_inet_pton(AF_UNSPEC, socks->address, &addr_tmp) &&
       options->AutomapHostsOnResolve && options->AutomapHostsSuffixes) {
     SMARTLIST_FOREACH(options->AutomapHostsSuffixes, const char *, cp,
                       if (!strcasecmpend(socks->address, cp)) {
                         automap = 1;
                         break;
                       });
-    if (automap) {
+    if (automap) { /* XXX-IPv6: Need to handle IPv6 here too? */
       const char *new_addr;
       new_addr = addressmap_register_virtual_address(
                               RESOLVED_TYPE_IPV4, tor_strdup(socks->address));
@@ -1730,20 +1742,20 @@ connection_ap_handshake_rewrite_and_attach(edge_connection_t *conn,
     }
 
     if (socks->command == SOCKS_COMMAND_RESOLVE) {
-      uint32_t answer;
-      struct in_addr in;
+      tor_addr_t addr;
       /* Reply to resolves immediately if we can. */
-      if (tor_inet_aton(socks->address, &in)) { /* see if it's an IP already */
-        /* leave it in network order */
-        answer = in.s_addr;
+      if (tor_inet_pton(AF_UNSPEC, socks->address, &addr)) { /* see if it's an IP already */
         /* remember _what_ is supposed to have been resolved. */
         strlcpy(socks->address, orig_address, sizeof(socks->address));
-        connection_ap_handshake_socks_resolved(conn,RESOLVED_TYPE_IPV4,4,
-                                               (uint8_t*)&answer,
-                                               -1,map_expires);
+        /* We do a tor_addr_raw() here but convert it back to a tor_addr in the function... */
+        connection_ap_handshake_socks_resolved(conn,
+               tor_addr_family(&addr) == AF_INET ? RESOLVED_TYPE_IPV4 : RESOLVED_TYPE_IPV6,
+               tor_addr_family(&addr) == AF_INET ? 4 : 16,
+               tor_addr_raw(&addr),
+               -1,map_expires);
         connection_mark_unattached_ap(conn,
-                                END_STREAM_REASON_DONE |
-                                END_STREAM_REASON_FLAG_ALREADY_SOCKS_REPLIED);
+               END_STREAM_REASON_DONE |
+               END_STREAM_REASON_FLAG_ALREADY_SOCKS_REPLIED);
         return 0;
       }
       tor_assert(!automap);
@@ -1945,7 +1957,7 @@ connection_ap_get_original_destination(edge_connection_t *conn,
   }
 
   tor_addr_from_sockaddr(&addr, (struct sockaddr*)&orig_dst, &req->port);
-  tor_addr_to_str(req->address, &addr, sizeof(req->address), 0);
+  tor_addr_to_str(&addr, req->address, sizeof(req->address), 0);
 
   return 0;
 #elif defined(TRANS_PF)
@@ -2006,7 +2018,7 @@ connection_ap_get_original_destination(edge_connection_t *conn,
     return -1;
   }
 
-  tor_addr_to_str(req->address, &addr, sizeof(req->address), 0);
+  tor_addr_to_str(&addr, req->address, sizeof(req->address), 0);
   req->port = ntohs(pnl.rdport);
 
   return 0;
@@ -2455,10 +2467,13 @@ tell_controller_about_resolved_result(edge_connection_t *conn,
 {
 
   if (ttl >= 0 && (answer_type == RESOLVED_TYPE_IPV4 ||
+                   answer_type == RESOLVED_TYPE_IPV6 ||
                    answer_type == RESOLVED_TYPE_HOSTNAME)) {
     return; /* we already told the controller. */
   } else if (answer_type == RESOLVED_TYPE_IPV4 && answer_len >= 4) {
-    char *cp = tor_dup_ip(get_uint32(answer));
+    tor_addr_t addr;
+    char *cp = NULL;
+    tor_addr_from_ipv4n(&addr, get_uint32(answer));
     control_event_address_mapped(conn->socks_request->address,
                                  cp, expires, NULL);
     tor_free(cp);
@@ -2467,6 +2482,14 @@ tell_controller_about_resolved_result(edge_connection_t *conn,
     control_event_address_mapped(conn->socks_request->address,
                                  cp, expires, NULL);
     tor_free(cp);
+  } else if (answer_type == RESOLVED_TYPE_IPV6 && answer_len >= 16) {
+    tor_addr_t addr;
+    char *cp = NULL;
+    tor_addr_from_ipv6_bytes(&addr, answer);
+    cp = tor_dup_ip(&addr);
+    control_event_address_mapped(conn->socks_request->address,
+                                 cp, expires, NULL);
+    tor_free(cp);
   } else {
     control_event_address_mapped(conn->socks_request->address,
                                  "<error>",
@@ -2497,16 +2520,21 @@ connection_ap_handshake_socks_resolved(edge_connection_t *conn,
 
   if (ttl >= 0) {
     if (answer_type == RESOLVED_TYPE_IPV4 && answer_len == 4) {
-      uint32_t a = ntohl(get_uint32(answer));
-      if (a)
-        client_dns_set_addressmap(conn->socks_request->address, a,
-                                  conn->chosen_exit_name, ttl);
+      tor_addr_t a;
+      tor_addr_from_ipv4n(&a, ntohl(get_uint32(answer)));
+      client_dns_set_addressmap(conn->socks_request->address, &a,
+                                conn->chosen_exit_name, ttl);
     } else if (answer_type == RESOLVED_TYPE_HOSTNAME && answer_len < 256) {
       char *cp = tor_strndup((char*)answer, answer_len);
       client_dns_set_reverse_addressmap(conn->socks_request->address,
                                         cp,
                                         conn->chosen_exit_name, ttl);
       tor_free(cp);
+    } else if (answer_type == RESOLVED_TYPE_IPV6 && answer_len == 16) {
+      tor_addr_t a;
+      tor_addr_from_ipv4n(&a, ntohl(get_uint32(answer)));
+      client_dns_set_addressmap(conn->socks_request->address, &a,
+                                conn->chosen_exit_name, ttl);
     }
   }
 
@@ -3083,12 +3111,11 @@ connection_ap_can_use_exit(edge_connection_t *conn, const node_t *exit)
 
   if (conn->socks_request->command == SOCKS_COMMAND_CONNECT &&
       !conn->use_begindir) {
-    struct in_addr in;
-    uint32_t addr = 0;
+    tor_addr_t addr;
     addr_policy_result_t r;
-    if (tor_inet_aton(conn->socks_request->address, &in))
-      addr = ntohl(in.s_addr);
-    r = compare_addr_to_node_policy(addr, conn->socks_request->port, exit);
+    if (!tor_inet_pton(AF_UNSPEC, conn->socks_request->address, &addr))
+      return 0; /* Failed to fixup address */
+    r = compare_tor_addr_to_node_policy(&addr, conn->socks_request->port, exit);
     if (r == ADDR_POLICY_REJECTED)
       return 0; /* We know the address, and the exit policy rejects it. */
     if (r == ADDR_POLICY_PROBABLY_REJECTED && !conn->chosen_exit_name)
diff --git a/src/or/connection_edge.h b/src/or/connection_edge.h
index 562db5b..8a4c9bc 100644
--- a/src/or/connection_edge.h
+++ b/src/or/connection_edge.h
@@ -77,7 +77,7 @@ int parse_virtual_addr_network(const char *val, int validate_only,
                                char **msg);
 int client_dns_incr_failures(const char *address);
 void client_dns_clear_failures(const char *address);
-void client_dns_set_addressmap(const char *address, uint32_t val,
+void client_dns_set_addressmap(const char *address, tor_addr_t *val,
                                const char *exitname, int ttl);
 const char *addressmap_register_virtual_address(int type, char *new_address);
 void addressmap_get_mappings(smartlist_t *sl, time_t min_expires,
diff --git a/src/or/connection_or.c b/src/or/connection_or.c
index 73aad7e..9397d92 100644
--- a/src/or/connection_or.c
+++ b/src/or/connection_or.c
@@ -462,10 +462,8 @@ connection_or_init_conn_from_address(or_connection_t *conn,
   tor_addr_copy(&conn->_base.addr, addr);
   tor_addr_copy(&conn->real_addr, addr);
   if (r) {
-    tor_addr_t node_addr;
-    node_get_addr(r, &node_addr);
     /* XXXX proposal 118 will make this more complex. */
-    if (tor_addr_eq(&conn->_base.addr, &node_addr))
+    if (tor_addr_eq(&conn->_base.addr, node_get_addr(r)))
       conn->is_canonical = 1;
     if (!started_here) {
       /* Override the addr/port, so our log messages will make sense.
@@ -478,12 +476,12 @@ connection_or_init_conn_from_address(or_connection_t *conn,
        * right IP address and port 56244, that wouldn't be as helpful. now we
        * log the "right" port too, so we know if it's moria1 or moria2.
        */
-      tor_addr_copy(&conn->_base.addr, &node_addr);
+      tor_addr_copy(&conn->_base.addr, node_get_addr(r));
       conn->_base.port = node_get_orport(r);
     }
     conn->nickname = tor_strdup(node_get_nickname(r));
     tor_free(conn->_base.address);
-    conn->_base.address = tor_dup_addr(&node_addr);
+    conn->_base.address = tor_dup_addr(node_get_addr(r));
   } else {
     const char *n;
     /* If we're an authoritative directory server, we may know a
@@ -592,7 +590,7 @@ connection_or_get_for_extend(const char *digest,
     if (conn->_base.state != OR_CONN_STATE_OPEN) {
       /* If the address matches, don't launch a new connection for this
        * circuit. */
-      if (!tor_addr_compare(&conn->real_addr, target_addr, CMP_EXACT))
+      if (!tor_addr_eq(&conn->real_addr, target_addr))
         ++n_inprogress_goodaddr;
       continue;
     }
@@ -609,7 +607,7 @@ connection_or_get_for_extend(const char *digest,
      * have an out-of-date descriptor, and we will get no NETINFO cell to
      * tell us about the right address.) */
     if (!conn->is_canonical && conn->link_proto >= 2 &&
-        tor_addr_compare(&conn->real_addr, target_addr, CMP_EXACT)) {
+        tor_addr_eq(&conn->real_addr, target_addr)) {
       ++n_noncanonical;
       continue;
     }
@@ -761,8 +759,7 @@ connection_or_group_set_badness(or_connection_t *head, int force)
                  (int)(now - or_conn->_base.timestamp_created),
                  best->_base.s, (int)(now - best->_base.timestamp_created));
         or_conn->is_bad_for_new_circs = 1;
-      } else if (!tor_addr_compare(&or_conn->real_addr,
-                                   &best->real_addr, CMP_EXACT)) {
+      } else if (!tor_addr_eq(&or_conn->real_addr, &best->real_addr)) {
         log_info(LD_OR,
                  "Marking OR conn to %s:%d as unsuitable for new circuits: "
                  "(fd %d, %d secs old).  We have a better one with the "
@@ -1352,9 +1349,7 @@ connection_or_set_state_open(or_connection_t *conn)
     /* only report it to the geoip module if it's not a known router */
     if (!router_get_by_id_digest(conn->identity_digest)) {
       if (tor_addr_family(&TO_CONN(conn)->addr) == AF_INET) {
-        /*XXXX IP6 support ipv6 geoip.*/
-        uint32_t a = tor_addr_to_ipv4h(&TO_CONN(conn)->addr);
-        geoip_note_client_seen(GEOIP_CLIENT_CONNECT, a, now);
+        geoip_note_client_seen(GEOIP_CLIENT_CONNECT, &TO_CONN(conn)->addr, now);
       }
     }
   }
@@ -1561,7 +1556,7 @@ connection_or_send_netinfo(or_connection_t *conn)
     tor_addr_t my_addr;
     *out++ = 1; /* only one address is supported. */
 
-    tor_addr_from_ipv4h(&my_addr, me->addr);
+    tor_addr_copy(&my_addr, &me->addr);
     len = append_address_to_payload(out, &my_addr);
     if (len < 0)
       return -1;
diff --git a/src/or/control.c b/src/or/control.c
index e0e8f7e..b867fbc 100644
--- a/src/or/control.c
+++ b/src/or/control.c
@@ -1393,12 +1393,12 @@ getinfo_helper_misc(control_connection_t *conn, const char *question,
   } else if (!strcmp(question, "features/names")) {
     *answer = tor_strdup("VERBOSE_NAMES EXTENDED_EVENTS");
   } else if (!strcmp(question, "address")) {
-    uint32_t addr;
+    tor_addr_t addr;
     if (router_pick_published_address(get_options(), &addr) < 0) {
       *errmsg = "Address unknown";
       return -1;
     }
-    *answer = tor_dup_ip(addr);
+    *answer = tor_dup_ip(&addr);
   } else if (!strcmp(question, "traffic/read")) {
     tor_asprintf(answer, U64_FORMAT, U64_PRINTF_ARG(get_bytes_read()));
   } else if (!strcmp(question, "traffic/written")) {
@@ -1561,9 +1561,11 @@ getinfo_helper_listeners(control_connection_t *control_conn,
     if (getsockname(conn->s, (struct sockaddr *)&ss, &ss_len) < 0) {
       tor_asprintf(&addr, "%s:%d", conn->address, (int)conn->port);
     } else {
-      char *tmp = tor_sockaddr_to_str((struct sockaddr *)&ss);
+      tor_addr_t a;
+      char tmp[128];
+      tor_addr_from_sockaddr(&a, (struct sockaddr *)&ss, NULL);
+      tor_addr_to_str(&a, tmp, sizeof(tmp),1);
       addr = esc_for_log(tmp);
-      tor_free(tmp);
     }
     if (addr)
       smartlist_add(res, addr);
@@ -3163,7 +3165,6 @@ control_event_circuit_status(origin_circuit_t *circ, circuit_status_event_t tp,
 {
   const char *status;
   char extended_buf[96];
-  int providing_reason=0;
   if (!EVENT_IS_INTERESTING(EVENT_CIRCUIT_STATUS))
     return 0;
   tor_assert(circ);
@@ -3187,7 +3188,6 @@ control_event_circuit_status(origin_circuit_t *circ, circuit_status_event_t tp,
     const char *reason_str = circuit_end_reason_to_control_string(reason_code);
     char *reason = NULL;
     size_t n=strlen(extended_buf);
-    providing_reason=1;
     if (!reason_str) {
       reason = tor_malloc(16);
       tor_snprintf(reason, 16, "UNKNOWN_%d", reason_code);
diff --git a/src/or/directory.c b/src/or/directory.c
index c0378a4..bb45f2f 100644
--- a/src/or/directory.c
+++ b/src/or/directory.c
@@ -296,7 +296,6 @@ directory_post_to_dirservers(uint8_t dir_purpose, uint8_t router_purpose,
   SMARTLIST_FOREACH_BEGIN(dirservers, trusted_dir_server_t *, ds) {
       routerstatus_t *rs = &(ds->fake_status);
       size_t upload_len = payload_len;
-      tor_addr_t ds_addr;
 
       if ((type & ds->type) == 0)
         continue;
@@ -320,9 +319,8 @@ directory_post_to_dirservers(uint8_t dir_purpose, uint8_t router_purpose,
         log_info(LD_DIR, "Uploading an extrainfo too (length %d)",
                  (int) extrainfo_len);
       }
-      tor_addr_from_ipv4h(&ds_addr, ds->addr);
       post_via_tor = purpose_needs_anonymity(dir_purpose, router_purpose) ||
-        !fascist_firewall_allows_address_dir(&ds_addr, ds->dir_port);
+        !fascist_firewall_allows_address_dir(&ds->addr, ds->dir_port);
       directory_initiate_command_routerstatus(rs, dir_purpose,
                                               router_purpose,
                                               post_via_tor,
@@ -422,10 +420,8 @@ directory_get_from_dirserver(uint8_t dir_purpose, uint8_t router_purpose,
       const node_t *node = choose_random_entry(NULL);
       if (node && node->ri) {
         /* every bridge has a routerinfo. */
-        tor_addr_t addr;
         routerinfo_t *ri = node->ri;
-        node_get_addr(node, &addr);
-        directory_initiate_command(ri->address, &addr,
+        directory_initiate_command(ri->address, node_get_addr(node),
                                    ri->or_port, 0,
                                    0, /* don't use conditional consensus url */
                                    1, ri->cache_info.identity_digest,
@@ -546,9 +542,7 @@ directory_initiate_command_routerstatus_rend(const routerstatus_t *status,
   or_options_t *options = get_options();
   const node_t *node;
   char address_buf[INET_NTOA_BUF_LEN+1];
-  struct in_addr in;
   const char *address;
-  tor_addr_t addr;
   node = node_get_by_id(status->identity_digest);
 
   if (!node && anonymized_connection) {
@@ -559,11 +553,9 @@ directory_initiate_command_routerstatus_rend(const routerstatus_t *status,
     node_get_address_string(node, address_buf, sizeof(address_buf));
     address = address_buf;
   } else {
-    in.s_addr = htonl(status->addr);
-    tor_inet_ntoa(&in, address_buf, sizeof(address_buf));
+    tor_addr_to_str(&status->addr, address_buf, sizeof(address_buf), 1);
     address = address_buf;
   }
-  tor_addr_from_ipv4h(&addr, status->addr);
 
   if (options->ExcludeNodes && options->StrictNodes &&
       routerset_contains_routerstatus(options->ExcludeNodes, status, -1)) {
@@ -575,7 +567,7 @@ directory_initiate_command_routerstatus_rend(const routerstatus_t *status,
     return;
   }
 
-  directory_initiate_command_rend(address, &addr,
+  directory_initiate_command_rend(address, &status->addr,
                              status->or_port, status->dir_port,
                              status->version_supports_conditional_consensus,
                              status->version_supports_begindir,
@@ -628,7 +620,7 @@ directory_conn_is_self_reachability_test(dir_connection_t *conn)
     const routerinfo_t *me = router_get_my_routerinfo();
     if (me &&
         router_digest_is_me(conn->identity_digest) &&
-        tor_addr_eq_ipv4h(&conn->_base.addr, me->addr) && /*XXXX prop 118*/
+        tor_addr_eq(&conn->_base.addr, &me->addr) && /*XXXX prop 118*/
         me->dir_port == conn->_base.port)
       return 1;
   }
@@ -1361,8 +1353,8 @@ http_set_address_origin(const char *headers, connection_t *conn)
   if (!fwd)
     fwd = http_get_header(headers, "X-Forwarded-For: ");
   if (fwd) {
-    struct in_addr in;
-    if (!tor_inet_aton(fwd, &in) || is_internal_IP(ntohl(in.s_addr), 0)) {
+    tor_addr_t addr;
+    if (!tor_inet_pton(AF_UNSPEC, fwd, &addr) || tor_addr_is_internal(&addr, 0)) {
       log_debug(LD_DIR, "Ignoring unrecognized or internal IP %s",
                 escaped(fwd));
       tor_free(fwd);
@@ -2799,9 +2791,9 @@ directory_handle_command_get(dir_connection_t *conn, const char *headers,
     }
 
     {
-      struct in_addr in;
-      if (tor_inet_aton((TO_CONN(conn))->address, &in)) {
-        geoip_note_client_seen(act, ntohl(in.s_addr), time(NULL));
+      tor_addr_t addr;
+      if (tor_inet_pton(AF_UNSPEC, (TO_CONN(conn))->address, &addr)) {
+        geoip_note_client_seen(act, &addr, time(NULL));
         geoip_note_ns_response(act, GEOIP_SUCCESS);
         /* Note that a request for a network status has started, so that we
          * can measure the download time later on. */
@@ -3238,7 +3230,7 @@ directory_handle_command_get(dir_connection_t *conn, const char *headers,
   }while(0);
 
   if (!strcmp(url,"/tor/mallinfo.txt") &&
-      (tor_addr_eq_ipv4h(&conn->_base.addr, 0x7f000001ul))) {
+      (tor_addr_is_loopback(&conn->_base.addr))) {
     char *result;
     size_t len;
     struct mallinfo mi;
